/**
	$Id: DataLoader.java 6029 2012-03-27 13:11:38Z nicklas $

	Copyright (C) 2009 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.plugins;

import net.sf.basedb.core.DbControl;

/**
 	A helper interface for the {@link SimpleExport} to get data 
 	that in some way are associated with an item.
 	
  	@author martin
 	@version 2.12
 	@base.modified $Date: 2012-03-27 15:11:38 +0200 (Tue, 27 Mar 2012) $
 */
public interface DataLoader<T>
{

	/**
		Get the value for the specified property.
		@param exportedProperty The property to get the value for
		@param item The item that holds the value
		@throws Exception If failing to get the data.
		@since 3.2 (Added DbControl parameter)
	*/
	public Object getData(DbControl dc, ExportedProperty exportedProperty, T item)
			throws Exception;

}