/*
	$Id $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/

package net.sf.basedb.core;

/**
	This exception is thrown when parsing a string into a date failed.

	@author Nicklas
	@since 2.16
*/
public class DateFormatException
	extends InvalidDataException
{

	private static final long serialVersionUID = -4312755232208681515L;

	/**
		Creates a new <code>DateFormatException</code>.
		@param message The message of the exception
	*/
	public DateFormatException(String message)
	{
		super(message);
	}

	/**
		Creates a new <code>DateFormatException</code>.
		@param message The message of the exception
		@param cause The root cause
	*/
	public DateFormatException(String message, Throwable cause)
	{
		super(message, cause);
	}

}
