/**
	$Id: Subtypable.java 5631 2011-05-16 12:56:23Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;


/**
	A subtypable item is an item that can have a subtype. Subtypes 
	are defined by {@link ItemSubtype} items.
	
	@author Nicklas
	@since 3.0
	@base.modified $Date: 2011-05-16 14:56:23 +0200 (Mon, 16 May 2011) $
*/
public interface Subtypable
	extends Identifiable
{
	/**
		Get the subtype of the item.
		@return A subtype of null if not set
		@see SubtypableRelatedItems
	*/
	public ItemSubtype getItemSubtype();
	
	/**
		Set the subtype on the item.
		
		@param subtype A subtype or null
		@see ItemSubtype#setOnItem(Subtypable)
	*/
	public void setItemSubtype(ItemSubtype subtype);
}
