/**
	$Id$

	Copyright (C) 2014 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.hibernate;

import java.sql.Connection;
import java.sql.SQLException;

import org.hibernate.jdbc.ReturningWork;

/**
	A work implementation that return the name of the current database catalog.

	@author nicklas
	@since 3.4
*/
public class GetCurrentCatalogWork
	implements ReturningWork<String>
{
	
	/**
		Create a new work item.
	*/
	public GetCurrentCatalogWork()
	{}
	
	/**
		From the Work interface
		-----------------------
	*/
	@Override
	public String execute(Connection connection) 
		throws SQLException
	{
		return connection.getCatalog();
	}
	// --------------------------
	

}
