/**
	$Id: AllowAnyHostNameVerifyer.java 6904 2015-05-12 11:40:29Z nicklas $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.ssl;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.SSLSession;

import net.sf.basedb.core.FileServer;


/**
	A simple implementation of a host name verifyer that allows all hosts.
	We use it to make sure that a server certificate that has been registered
	with a {@link FileServer} always work even if the server has a different name
	than what is in the certificate.
	
	@author Nicklas
	@since 2.16
	@base.modified $Date: 2015-05-12 13:40:29 +0200 (Tue, 12 May 2015) $
*/
public class AllowAnyHostNameVerifyer
	implements HostnameVerifier
{

	public AllowAnyHostNameVerifyer()
	{}

	@Override
	public boolean verify(String hostname, SSLSession session)
	{
		return true;
	}
}
