<%-- $Id:view_filetype.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.PlatformFileType"
	import="net.sf.basedb.core.ItemSubtypeFileType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.DATAFILETYPE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getStringOrNull(request.getParameter("tab"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":View "+itemType);
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	DataFileType fileType = DataFileType.getById(dc, itemId);
	
	final boolean writePermission = fileType.hasPermission(Permission.WRITE);
	final boolean deletePermission = fileType.hasPermission(Permission.DELETE);
	final boolean isRemoved = fileType.isRemoved();
	final boolean isUsed = isRemoved && fileType.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, fileType);
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="tabcontrol-2.js,~filetypes.js" styles="toolbar.css,headertabcontrol.css,path.css,table.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Data file types" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(fileType.getName())%>" 
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon 
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this data file type" : "You do not have permission to edit this data file type"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!fileType.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this data file type" : "You do not have permission to delete this data file type"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=fileType.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this data file type" : "You do not have permission to restore this data file type"%>" 
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="datafiletype.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(fileType.getName())%></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><%=HTML.encodeTags(fileType.getExternalId())%></td>
			</tr>
			<tr>
				<th>Item type</th>
				<td><%=fileType.getItemType()%></td>
			</tr>
			<tr>
				<th>File extension</th>
				<td><%=HTML.encodeTags(fileType.getExtension())%></td>
			</tr>
			<tr>
				<th>Generic file type</th>
				<td><base:propertyvalue item="<%=fileType%>" property="genericType" /></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(fileType)%></td>
			</tr>
			<tr >
				<th>Description</th>
				<td><%=HTML.niceFormat(fileType.getDescription())%></td>
			</tr>
			</table>
			</div>
			<%
			ItemQuery<PlatformFileType> platformQuery = fileType.getPlatforms();
			platformQuery.include(Include.ALL);
			platformQuery.order(Orders.asc(Hql.property("platform.name")));
			ItemResultList<PlatformFileType> platforms = platformQuery.list(dc);
			%>
			<base:section 
				id="platforms"
				title="<%="Used on platforms (" + platforms.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (platforms.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					This file type is not used by any platforms or variants
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="tbl.platforms"
						columns="all"
						>
						<tbl:columndef 
							id="platform"
							title="Platform"
						/>
						<tbl:columndef 
							id="variant"
							title="Variant"
						/>
						<tbl:columndef 
							id="required"
							title="Required"
						/>
						<tbl:columndef 
							id="multiple"
							title="Multiple files"
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							for (PlatformFileType item : platforms)
							{
								Platform p = item.getPlatform();
								PlatformVariant v = item.getVariant();
								%>
								<tbl:row>
									<tbl:cell column="platform"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=p.isRemoved()%>"
										/><%=Base.getLinkedName(ID, p, false, true)%></tbl:cell>
									<tbl:cell column="variant"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=v!= null && v.isRemoved()%>"
										/><%=v == null ? "<i>- all -</i>" : Base.getLinkedName(ID, v, false, true)%></tbl:cell>
									<tbl:cell column="required"><%=item.isRequired() ? "yes" : "no"%></tbl:cell>
									<tbl:cell column="multiple"><%=item.getAllowMultiple() ? "yes" : "no"%></tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<%
			ItemQuery<ItemSubtypeFileType> subtypeQuery = ItemSubtypeFileType.getQuery(fileType);
			subtypeQuery.include(Include.ALL);
			subtypeQuery.order(Orders.asc(Hql.property("itemSubtype.name")));
			ItemResultList<ItemSubtypeFileType> subtypes = subtypeQuery.list(dc);
			%>
			<base:section 
				id="subtypes"
				title="<%="Used by item subtypes (" + subtypes.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (subtypes.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					This file type is not used by any item subtypes
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="tbl.subtypes"
						columns="all"
						>
						<tbl:columndef 
							id="subtype"
							title="Item subtype"
						/>
						<tbl:columndef 
							id="required"
							title="Required"
						/>
						<tbl:columndef 
							id="multiple"
							title="Multiple files"
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							for (ItemSubtypeFileType item : subtypes)
							{
								ItemSubtype st = item.getItemSubtype();
								%>
								<tbl:row>
									<tbl:cell column="subtype"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=st.isRemoved()%>"
										/><%=Base.getLinkedName(ID, st, false, true)%></tbl:cell>
									<tbl:cell column="required"><%=item.isRequired() ? "yes" : "no"%></tbl:cell>
									<tbl:cell column="multiple"><%=item.getAllowMultiple() ? "yes" : "no"%></tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this file type" />
			</jsp:include>
			
			</t:tab>
			</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
