<%-- $Id:manual_scan.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.manager.ExtensionsFile"
	import="net.sf.basedb.util.extensions.manager.ProcessResults"
	import="net.sf.basedb.util.extensions.manager.ProcessResults.FileResults"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.formatter.Formatter"
	import="java.util.Date"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl(":Extension scan results");
	ExtensionsControl ec = ExtensionsControl.get(dc);
	ProcessResults results = ec.getLastScanResults();
	Formatter<Date> timeFormatter = FormatterFactory.getDateTimeFormatter(sc);
%>
	<base:page type="popup" title="Last installation results">
	<base:head scripts="~scan_results.js" />
	<base:body>
	<h1>Last installation results</h1>
	
	<div class="content bottomborder">

		<table class="fullform outlined">
		<tr>
			<th>Status</th>
			<td><%=results.hasError() ? "Error" : "Success" %></td>
		</tr>
		<tr>
			<th class="subprompt">Started</th>
			<td><%=timeFormatter.format(new Date(results.getStartTime()))%></td>
		</tr>
		<tr>
			<th class="subprompt">Ended</th>
			<td><%=timeFormatter.format(new Date(results.getEndTime()))%></td>
		</tr>
		<tr>
			<th>Summary</th>
			<td><%=HTML.niceFormat(results.getSummary())%></td>
		</tr>
		<%
		for (FileResults fileResults : results.getAllResults())
		{
			ExtensionsFile extFile = fileResults.getExtensionsFile();
			List<Extension<?>> unsafe = ec.checkUnsafeScriptableUsage(extFile);
			String detailsId = Integer.toString(extFile.hashCode());
			List<String> messages = fileResults.getMessages();
			Throwable validationError = extFile.getValidationError();
			String icon = "ok.png";
			String warning = null;
			if (extFile.hasError() && !extFile.isIgnored())
			{
				icon = "error.png";
			}
			else if (unsafe.size() > 0)
			{
				icon = "warning.png";
				warning = "This plug-in contain "+unsafe.size() + " extension(s) that " +
					"may violate the <b>Content Security Policy</b> setting on this server. "+
					"See BASE documentation for more information.";
			}
			boolean hasMessages = (messages != null && messages.size() > 0) || validationError != null || warning != null;
			%>
			<tr>
				<th><%=extFile.getName() %></th>
				<td><base:icon image="<%=icon%>" />&nbsp;<%=fileResults.getStatus() %>
				<base:icon 
					id="<%="icon." + detailsId %>" 
					subclass="auto-init"
					data-auto-init="details"
					data-details-id="<%=detailsId%>"
					image="move_right.png" 
					visible="<%=hasMessages%>"
				/>
				</td>
			</tr>
			<%
			if (hasMessages)
			{
				%>
				<tr id="details.<%=detailsId %>" style="display:none;">
					<th class="subprompt"></th><td>
					<ul style="padding-left: 20px; margin: 0px; text-align: left;">
					<%
					for (String msg : messages)
					{
						%>
						<li><%=HTML.niceFormat(msg)%>
						<%
					}
					if (validationError != null)
					{
						%>
						<li><%=validationError.getClass().getSimpleName()%>: <%=HTML.niceFormat(validationError.getMessage())%>
						<%
					}
					if (warning != null)
					{
						%>
						<li><%=warning %>
						<%
					}
					%>
					</ul>
					</td>
				</tr>
				<%
			}
		}
		%>
		<tr class="dynamic">
			<th></th>
			<td></td>
		</tr>
		</table>
	</div>
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button id="close" title="Close" />
	</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
