<%-- $Id: broadcast.jsp 7954 2021-05-12 13:27:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ClientDefaultSetting"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Edit broadcast message");

try
{
	final Client server = Client.getById(dc, sc.getClientId());
	final boolean writePermission = server.hasPermission(Permission.WRITE);
	
	String title = (String)application.getAttribute("broadcast.title");
	String message = (String)application.getAttribute("broadcast.message");
	Boolean denyLogin = (Boolean)application.getAttribute("broadcast.deny-login");
	%>
	<base:page type="popup" title="Broadcast message">
	<base:head scripts="~broadcast.js" />
	<base:body>
		<h1>Broadcast message <base:help helpid="broadcast.message"/></h1>
		<form name="broadcast" action="submit_server.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="SetBroadcastMessage">
	
		<div class="content bottomborder">
		<%
		if (!writePermission)
		{
			%>
			<table class="fullcc bg-filled-50"><tr><td>
			<div class="messagecontainer error">You do not have permission to broadcast messages to users.</div>
			</td></tr></table>
			<%
		}
		else
		{
			%>
			<table class="fullform smaller input100">
			<tr>
				<th>Title</th>
				<td>
					<input class="text auto-init" data-auto-init="focus"
						type="text" name="title" value="<%=HTML.encodeTags(title)%>" maxlength="255">
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Disable login</th>
				<td>
					<input type="checkbox" name="denyLogin" <%=Boolean.TRUE.equals(denyLogin) ? "checked": ""%> value="1">
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Message</th>
				<td>
					<textarea class="text" rows="15" name="message" id="message"><%=HTML.encodeTags(message)%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="message" title="Message" />
				</td>
			</tr>
			</table>
			<%
		}
		%>
		</div>

		</form>
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnClear" image="remove.png" title="Clear message" />
			<base:button id="btnSave" title="Ok" visible="<%=writePermission%>"/>
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

