/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Download = function()
{
	var download = {};

	/**
		Initialize the page.
	*/
	download.initPage = function()
	{
		// Buttons
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnCancel', download.cancelWizard);
		Buttons.addClickHandler('btnDownload', download.downloadExport);
	}
	
	download.cancelWizard = function()
	{
		location = 'index.jsp?ID='+App.getSessionId()+'&cmd=CancelWizard';
	}
	
	download.downloadExport = function()
	{
		Doc.hide('download');
		Doc.hide('beforeDownloadInfo');
		Doc.show('afterDownloadInfo');
		Doc.show('progress');		
		Doc.element('downloadFrame').src = 'index.jsp?ID='+App.getSessionId()+'&cmd=ExportImmediately';
		download.sendProgressUpdateWithAjax();
	}

	download.sendProgressUpdateWithAjax = function()
	{
		var request = Ajax.getXmlHttpRequest();
		if (request != null)
		{
			var url = 'progress.jsp?ID='+App.getSessionId()+'&ajax=1&'+Math.random();
			request.open("GET", url, true);
			Ajax.setReadyStateHandler(request, download.updateProgressWithAjax);
			request.send(null);
		}
		return request != null;
	}
	
	download.updateProgressWithAjax = function(request)
	{
		var progress = JSON.parse(request.responseText);
		var needMoreUpdate = true;
		if (progress && progress.status == 'ok')
		{
			download.displayProgress(progress);
			if (progress.percent >= 100) 
			{
				needMoreUpdate = false;
			}
		}
		if (needMoreUpdate)
		{
			setTimeout(download.sendProgressUpdateWithAjax, 1500);
		}
	}
	
	download.displayProgress = function(progress)
	{
		var percentDone = progress.percent; 
		Doc.element('percentText').innerHTML = percentDone+'%';
		Doc.element('percentDone').style.width = percentDone+'%';
		Doc.element('percentRemain').style.width = (100-percentDone)+'%';
		if (progress.message)
		{
			Doc.element('message').innerHTML = progress.message;
		}
		if (percentDone == 100) 
		{
			Doc.hide('percentRemain');
			Doc.hide('btnCancel');
			Doc.show('close');
		}
	}
	
	return download;
}();

Doc.onLoad(Download.initPage);