<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json"
	import="net.sf.basedb.core.PlateMapping"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.data.MappingCoordinate"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%
response.setHeader("Cache-Control", "no-cache, max-age=0");
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
try
{
	if ("GetMappingDetails".equals(cmd))
	{
		dc = sc.newDbControl(":Get plate mapping information");
		
		PlateMapping mapping = PlateMapping.getById(dc, itemId);
		PlateGeometry destGeometry = mapping.getDestinationGeometry();
		PlateGeometry sourceGeometry = mapping.getSourceGeometry();

		json.put("id", mapping.getId());
		json.put("name", mapping.getName());
		json.put("sourcePlates", mapping.getSourceCount());
		json.put("sourceRows", sourceGeometry.getRows());
		json.put("sourceColumns", sourceGeometry.getColumns());
		json.put("destinationPlates", mapping.getDestinationCount());
		json.put("destinationRows", destGeometry.getRows());
		json.put("destinationColumns", destGeometry.getColumns());

		JSONArray jsonDetails = new JSONArray();
		for (int plateNo = 0; plateNo < mapping.getDestinationCount(); ++plateNo)
		{
			for (int row = 0; row < destGeometry.getRows(); ++row)
			{
				for (int col = 0; col < destGeometry.getColumns(); ++col)
				{
					MappingCoordinate dest = new MappingCoordinate(plateNo, row, col);
					MappingCoordinate src = mapping.getSourceCoordinate(dest);
					if (src != null)
					{
						jsonDetails.add(src.getPlate() + "," + src.getRow() + "," + src.getColumn() + 
								"," + plateNo + "," + row + "," + col);
					}
				}
			}
		}
		json.put("details", jsonDetails);
		dc.close();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>