/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var List = function()
{
	var list = {};
	
	/**
		Initialize the page.
	*/
	list.initPage = function()
	{
		var attributes = {'item-type': 'REPORTER'};
		var tableAttributes = {'table-id': 'reporters'};
		
		Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
		Buttons.addClickHandler('btnNewReporterList', list.newReporterList);
		
		TabControl.addTabActivateListener('explorer.view', list.viewReporter);
	
	}
	
	list.initElements = function(element, autoInit)
	{
		if (autoInit == 'view-reporter')
		{
			Events.addEventHandler(element, 'click', list.viewReporter);
		}
	}
	
	list.newReporterList = function()
	{
		var controller = Items.getController('REPORTERLIST');
		Table.submitToPopup('reporters', 'CreateReporterList', controller.width, controller.height);
	}

	list.viewReporter = function(event)
	{
		var frm = document.forms['reporters'];		
		var url = '../view/index.jsp?ID='+App.getSessionId();
		url += '&bioassayset_id='+frm.bioassayset_id.value;
		
		var index = Data.int(event.currentTarget, 'index');
		if (index >= 0)
		{
			url += '&cmd=SetReporterIndex&reporterIndex='+index;
		}
		location.href = url;
	}
	
	return list;
}();

Doc.onLoad(List.initPage);
Doc.addElementInitializer(List.initElements);

